import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class nC {
	StringTokenizer st;
	BufferedReader in;
	PrintWriter out;

	class mPair implements Comparable<mPair> {
		int a, b;

		public mPair(int a, int b) {
			this.a = a;
			this.b = b;
		}

		public mPair(mPair c) {
			this.a = c.a;
			this.b = c.b;
		}

		@Override
		public int compareTo(mPair o) {
			if (this.a != o.a) {
				return this.a - o.a;
			}
			return this.b - o.b;
		}

	}

	private void run() throws IOException {
		in = new BufferedReader(new InputStreamReader(System.in));
		out = new PrintWriter(System.out);

		int n = nextInt();
		int m = nextInt();
		int[] a = new int[m];
		int[] b = new int[n];
		ArrayList<Integer> al = new ArrayList<>();
		ArrayList<Integer>[] as = new ArrayList[n];
		int num = 0;
		for (int i = 0; i < m; i++) {
			a[i] = nextInt() - 1;
			if (as[a[i]] == null) {
				as[a[i]] = new ArrayList<>();
			}
			as[a[i]].add(i);
		}
		for (int i = 0; i < n; i++) {
			b[i] = nextInt() - 1;
			if (b[i] == a[0]) {
				num = i;
			}

		}

		for (int i = 0; i < m - 1; i++) {
			ArrayList<Integer> upd = new ArrayList<>();
			for (int l = num + 1; l < n; l++) {
				upd.add(b[l]);
			}
			for (int r = 0; r < num; r++) {
				boolean flag = false;
				if (as[b[r]] == null) {
					as[b[r]] = new ArrayList<>();
				}

				if (!(as[b[r]].isEmpty())) {
					for (int q = 0; q < upd.size(); q++) {
						if (as[upd.get(q)] == null) {
							as[upd.get(q)] = new ArrayList<>();
						}
						if ((as[upd.get(q)].isEmpty()) || as[b[r]].get(0) < as[upd.get(q)].get(0)) {
							flag = true;
							upd.add(q, b[r]);
							al.add(num - r + q + 1);
							break;
						}

					}
				}
				if (!flag) {
					upd.add(b[r]);
					al.add(n);
				}
			}
			int d = 0;
			if(a[i+1] == a[i]) {
				al.add(1);
				continue;
			}
			as[b[num]].remove(0);
			int tmp = b[num];
			for (int j = 0; j < upd.size(); j++) {
				b[j + d] = upd.get(j);
				if (i < m - 1 && b[j] == a[i + 1]) {
					num = j;
				}
			}
			boolean flag = false;
			if (!as[tmp].isEmpty()) {
				for (int q = num + 1; q < n - 1; q++) {
					if (as[b[q]] == null) {
						as[b[q]] = new ArrayList<>();
					}
					if ((as[b[q]].isEmpty()) || as[tmp].get(0) < as[b[q]].get(0)) {
						flag = true;
						for (int l = n - 1; l > q; l--) {
							b[l] = b[l - 1];
						}
						b[q] = tmp;
						al.add(q + 1);
						break;
					}

				}
			}

			if (!flag) {
				b[n - 1] = tmp;
				al.add(n);
			}
		}
		al.add(n);

		out.println(al.size());
		for (int i = 0; i < al.size(); i++) {
			out.print(al.get(i) + " ");
		}

		out.close();
	}

	private String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}

	private int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	private long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		new nC().run();

	}

}
