import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class mC {
	StringTokenizer st;
	BufferedReader in;
	PrintWriter out;
	ArrayList<Integer>[] al1;
	ArrayList<Integer>[] al2;
	int[] used;
	int[] deg;

	private void dfs(int num) {
		if (deg[num] != 0) {
			for (int i = 0; i < al1[num].size(); i++) {
				int v = al1[num].get(i);
				deg[v]--;
				al1[v].remove((Object) num);
			}
			deg[num] = -1;
		}
	}

	private void run() throws IOException {
		in = new BufferedReader(new InputStreamReader(System.in));
		out = new PrintWriter(System.out);
		int n = nextInt();
		al1 = new ArrayList[n];
		deg = new int[n];
		int[] a = new int[n];
		int maxNum = 0;
		int max = 0;
		int[][] arr = new int[n][n];
		for (int i = 0; i < n; i++) {
			int num = nextInt();
			a[i] = num;
			if (al1[i] == null) {
				al1[i] = new ArrayList<>();
			}
			if (num != -1) {
				if (al1[num - 1] == null) {
					al1[num - 1] = new ArrayList<>();
				}
				if (arr[i][num - 1] == 0) {
					arr[i][num - 1]++;
					arr[num - 1][i]++;

					al1[i].add(num - 1);
					al1[num - 1].add(i);
					deg[i]++;
					deg[num - 1]++;
					if (max < deg[i]) {
						max = deg[i];
						maxNum = i;
					}
					if (max < deg[num - 1]) {
						max = deg[num - 1];
						maxNum = num - 1;
					}

				}
			}

		}
		int count = 0;
		while (true) {
			dfs(maxNum);
			max = 0;
			maxNum = 0;
			count = 0;
			for (int i = 0; i < n; i++) {
				if (max < deg[i]) {
					max = deg[i];
					maxNum = i;
				}
				if (deg[i] == 0) {
					count++;
				}
			}
			if (max == 0) {
				break;
			}
		}

		System.out.println(count);

		out.close();
	}

	private String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}

	private int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	private long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		new mC().run();

	}

}
